Project Chrono: chrono::vehicle::bmw::BMW_E90_AntiRollBarRear Class Reference

Public Member Functions | List of all members
chrono::vehicle::bmw::BMW_E90_AntiRollBarRear Class Reference
Models » Vehicle models » BMW E90 vehicle

## Description

Anti-roll bar subsystem for a FEDA vehicle.

`#include <BMW_E90_AntiRollBarRear.h>`

Inheritance diagram for chrono::vehicle::bmw::BMW_E90_AntiRollBarRear:
[legend]
Collaboration diagram for chrono::vehicle::bmw::BMW_E90_AntiRollBarRear:
[legend]

## Public Member Functions
| BMW_E90_AntiRollBarRear (const std::string &name)
virtual double | getArmMass () const override
| Return the mass of the arm body.
virtual ChVector3d | getArmInertia () override
| Return the moments of inertia of the arm body.
virtual double | getArmLength () const override
| Return the arm length (dimension in y direction).
virtual double | getArmWidth () const override
| Return the arm width (dimension in X direction).
virtual double | getDroplinkHeight () const override
| Return height of droplinks (dimension in Z direction).
virtual double | getArmRadius () const override
| Return radius of arm (visualization only).
virtual double | getSpringCoefficient () const override
| Return the rotational spring coefficient.
virtual double | getDampingCoefficient () const override
| Return the rotational damping coefficient.
Public Member Functions inherited from chrono::vehicle::ChAntirollBarRSD
| ChAntirollBarRSD (const std::string &name)
virtual std::string | GetTemplateName () const override
| Get the name of the vehicle subsystem template.
virtual void | Initialize (std::shared_ptr< ChChassis > chassis, std::shared_ptr< ChSuspension > suspension, const ChVector3d &location) override
| Initialize this anti-roll bar subsystem.
virtual void | LogConstraintViolations () override
| Log current constraint violations.
Public Member Functions inherited from chrono::vehicle::ChPart
const std::string & | GetName () const
| Get the name identifier for this subsystem.
void | SetName (const std::string &name)
| Set the name identifier for this subsystem.
bool | IsInitialized () const
| Return flag indicating whether or not the part is fully constructed.
double | GetMass () const
| Get the subsystem mass.
const ChFrame & | GetCOMFrame () const
| Get the current subsystem COM frame (relative to and expressed in the subsystem's reference frame).
const ChMatrix33 & | GetInertia () const
| Get the current subsystem inertia (relative to the subsystem COM frame).
const ChFrame & | GetTransform () const
| Get the current subsystem position relative to the global frame.
void | SetVisualizationType (VisualizationType vis)
| Set the visualization mode for this subsystem.
virtual void | AddVisualizationAssets (VisualizationType vis)
| Add visualization assets to this subsystem, for the specified visualization mode.
virtual void | RemoveVisualizationAssets ()
| Remove all visualization assets from this subsystem.
virtual void | SetOutput (bool state)
| Enable/disable output for this subsystem.
bool | OutputEnabled () const
| Return the output state for this subsystem.

## Additional Inherited Members
Static Public Member Functions inherited from chrono::vehicle::ChPart
static ChMatrix33 | TransformInertiaMatrix (const ChVector3d &moments, const ChVector3d &products, const ChMatrix33<> &vehicle_rot, const ChMatrix33<> &body_rot)
| Utility function for transforming inertia tensors between centroidal frames.
Protected Member Functions inherited from chrono::vehicle::ChAntirollBarRSD
virtual void | InitializeInertiaProperties () override
| Initialize subsystem inertia properties.
virtual void | UpdateInertiaProperties () override
| Update subsystem inertia properties.
Protected Member Functions inherited from chrono::vehicle::ChAntirollBar
| ChAntirollBar (const std::string &name)
| Construct an anti-roll bar subsystem with given name.
Protected Member Functions inherited from chrono::vehicle::ChPart
| ChPart (const std::string &name)
| Construct a vehicle subsystem with the specified name.
void | AddMass (double &mass)
| Add this subsystem's mass.
void | AddInertiaProperties (ChVector3d &com, ChMatrix33<> &inertia)
| Add this subsystem's inertia properties.
virtual void | Create (const rapidjson::Document &d)
| Create a vehicle subsystem from JSON data.
void | ExportBodyList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChBody > > bodies) const
| Export the list of bodies to the specified JSON document.
void | ExportShaftList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChShaft > > shafts) const
| Export the list of shafts to the specified JSON document.
void | ExportJointList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLink > > joints) const
| Export the list of joints to the specified JSON document.
void | ExportCouplesList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChShaftsCouple > > couples) const
| Export the list of shaft couples to the specified JSON document.
void | ExportMarkerList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChMarker > > markers) const
| Export the list of markers to the specified JSON document.
void | ExportLinSpringList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLinkTSDA > > springs) const
| Export the list of translational springs to the specified JSON document.
void | ExportRotSpringList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLinkRSDA > > springs) const
| Export the list of rotational springs to the specified JSON document.
void | ExportBodyLoadList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLoadBodyBody > > loads) const
| Export the list of body-body loads to the specified JSON document.
Static Protected Member Functions inherited from chrono::vehicle::ChPart
static void | RemoveVisualizationAssets (std::shared_ptr< ChPhysicsItem > item)
| Erase all visual shapes from the visual model associated with the specified physics item (if any).
static void | RemoveVisualizationAsset (std::shared_ptr< ChPhysicsItem > item, std::shared_ptr< ChVisualShape > shape)
| Erase the given shape from the visual model associated with the specified physics item (if any).
Protected Attributes inherited from chrono::vehicle::ChAntirollBarRSD
std::shared_ptr< ChBody > | m_arm_left
| handle to the left arm body
std::shared_ptr< ChBody > | m_arm_right
| handle to the right arm body
std::shared_ptr< ChLinkLockRevolute > | m_revolute_ch
| handle to revolute joint to chassis
std::shared_ptr< ChLinkLockRevolute > | m_revolute
| handle to central revolute joint
std::shared_ptr< ChLinkDistance > | m_link_left
| handle to the left droplink distance constraint
std::shared_ptr< ChLinkDistance > | m_link_right
| handle to the right droplink distance constraint
Protected Attributes inherited from chrono::vehicle::ChAntirollBar
ChVector3d | m_rel_loc
| relative location of antiroll bar subsystem on chassis
Protected Attributes inherited from chrono::vehicle::ChPart
std::string | m_name
| subsystem name
bool | m_initialized
| specifies whether ot not the part is fully constructed
bool | m_output
| specifies whether or not output is generated for this subsystem
std::shared_ptr< ChPart > | m_parent
| parent subsystem (empty if parent is vehicle)
double | m_mass
| subsystem mass
ChMatrix33 | m_inertia
| inertia tensor (relative to subsystem COM)
ChFrame | m_com
| COM frame (relative to subsystem reference frame).
ChFrame | m_xform
| subsystem frame expressed in the global frame

## Member Function Documentation

## ◆ getArmInertia()

virtual ChVector3d chrono::vehicle::bmw::BMW_E90_AntiRollBarRear::getArmInertia | ( |  | ) |
| inlineoverridevirtual

Return the moments of inertia of the arm body.

Implements chrono::vehicle::ChAntirollBarRSD.

## ◆ getArmLength()

virtual double chrono::vehicle::bmw::BMW_E90_AntiRollBarRear::getArmLength | ( |  | ) | const
| inlineoverridevirtual

Return the arm length (dimension in y direction).

Implements chrono::vehicle::ChAntirollBarRSD.

## ◆ getArmMass()

virtual double chrono::vehicle::bmw::BMW_E90_AntiRollBarRear::getArmMass | ( |  | ) | const
| inlineoverridevirtual

Return the mass of the arm body.

Implements chrono::vehicle::ChAntirollBarRSD.

## ◆ getArmRadius()

virtual double chrono::vehicle::bmw::BMW_E90_AntiRollBarRear::getArmRadius | ( |  | ) | const
| inlineoverridevirtual

Return radius of arm (visualization only).

Implements chrono::vehicle::ChAntirollBarRSD.

## ◆ getArmWidth()

virtual double chrono::vehicle::bmw::BMW_E90_AntiRollBarRear::getArmWidth | ( |  | ) | const
| inlineoverridevirtual

Return the arm width (dimension in X direction).

Implements chrono::vehicle::ChAntirollBarRSD.

## ◆ getDampingCoefficient()

virtual double chrono::vehicle::bmw::BMW_E90_AntiRollBarRear::getDampingCoefficient | ( |  | ) | const
| inlineoverridevirtual

Return the rotational damping coefficient.

Implements chrono::vehicle::ChAntirollBarRSD.

## ◆ getDroplinkHeight()

virtual double chrono::vehicle::bmw::BMW_E90_AntiRollBarRear::getDroplinkHeight | ( |  | ) | const
| inlineoverridevirtual

Return height of droplinks (dimension in Z direction).

Implements chrono::vehicle::ChAntirollBarRSD.

## ◆ getSpringCoefficient()

virtual double chrono::vehicle::bmw::BMW_E90_AntiRollBarRear::getSpringCoefficient | ( |  | ) | const
| inlineoverridevirtual

Return the rotational spring coefficient.

Implements chrono::vehicle::ChAntirollBarRSD.

The documentation for this class was generated from the following files:

- D:/W/B/src/chrono-9.0.1/src/chrono_models/vehicle/bmw/BMW_E90_AntiRollBarRear.h
- D:/W/B/src/chrono-9.0.1/src/chrono_models/vehicle/bmw/BMW_E90_AntiRollBarRear.cpp